VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "JukePlugin"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Attribute VB_Ext_KEY = "SavedWithClassBuilder6" ,"Yes"
Attribute VB_Ext_KEY = "Top_Level" ,"Yes"
Option Explicit

Private Type PluginInfoType
    Name As String
    Author As String
    Version As String
    Description As String
End Type

Private pDC As Long
Private hDll As Long

Private pInitialize As Long
Private pShutdown As Long
Private pGetPluginInfo As Long
Private pCommand As Long

Private PluginInfo As PluginInfoType

Public Function Initialize(hDC As Long, PluginName As String) As Long
    Dim RetVal As Long
    
    pDC = hDC
    hDll = LoadLibrary(PluginName)
       
    pGetPluginInfo = GetProcAddress(hDll, "Juke_GetPluginInfo")
    
    If IsPlugin Then
        pInitialize = GetProcAddress(hDll, "Juke_Initialize")
        pShutdown = GetProcAddress(hDll, "Juke_Shutdown")
        pCommand = GetProcAddress(hDll, "Juke_Command")
        
        If pGetPluginInfo <> 0 Then
            Dim sPluginInfo As String
            Dim sArray() As String
            
            sPluginInfo = PtrToVBString(CallFuncPtr(pDC, pGetPluginInfo, vbNull))
                       
            sArray = Split(sPluginInfo, "|")
        
            If UBound(sArray) + 1 = 4 Then
                PluginInfo.Name = sArray(0)
                PluginInfo.Author = sArray(1)
                PluginInfo.Version = sArray(2)
                PluginInfo.Description = sArray(3)
            End If
        End If
        
        If pInitialize <> 0 Then
            RetVal = CallFuncPtr(pDC, pInitialize, vbNull)
        End If
    Else
        RetVal = Shutdown
    End If
    
    Initialize = RetVal
End Function

Public Function Shutdown() As Long
    Dim RetVal As Long
    If pShutdown <> 0 Then
        RetVal = CallFuncPtr(pDC, pShutdown, vbNull)
    End If
    FreeLibrary hDll
    Shutdown = RetVal
End Function

Public Function Command(Name As String, Value As String) As String()
    Dim sCommand As String
    Dim sArray() As String
    If pCommand <> 0 Then
        sCommand = PtrToVBString(CallFuncPtr(pDC, pCommand, Name, Value))
        sArray = Split(sCommand, "|")
    End If
    Command = sArray
End Function

Public Property Get IsPlugin() As Boolean
    IsPlugin = (pGetPluginInfo <> 0)
End Property

Public Property Get Name() As String
   Name = PluginInfo.Name
End Property

Public Property Get Author() As String
   Author = PluginInfo.Author
End Property

Public Property Get Version() As String
   Version = PluginInfo.Version
End Property

Public Property Get Description() As String
   Description = PluginInfo.Description
End Property

